import pygame
import random

# 初始化 Pygame
pygame.init()

# 游戏常量
WIDTH, HEIGHT = 600, 400
GRID_SIZE = 20
SNAKE_SPEED = 10
WHITE = (255, 255, 255)
BLACK = (0, 0, 0)
RED = (255, 0, 0)
GREEN = (0, 255, 0)

# 设置窗口
screen = pygame.display.set_mode((WIDTH, HEIGHT))
pygame.display.set_caption("贪吃蛇")
clock = pygame.time.Clock()

# 初始化贪吃蛇
snake = [(WIDTH // 2, HEIGHT // 2)]
snake_direction = (1, 0)  # 初始方向向右

# 初始化食物
food = (random.randrange(0, WIDTH // GRID_SIZE) * GRID_SIZE,
        random.randrange(0, HEIGHT // GRID_SIZE) * GRID_SIZE)

# 游戏循环
running = True
while running:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            running = False
        if event.type == pygame.KEYDOWN:
            if event.key == pygame.K_UP and snake_direction != (0, 1):
                snake_direction = (0, -1)
            if event.key == pygame.K_DOWN and snake_direction != (0, -1):
                snake_direction = (0, 1)
            if event.key == pygame.K_LEFT and snake_direction != (1, 0):
                snake_direction = (-1, 0)
            if event.key == pygame.K_RIGHT and snake_direction != (-1, 0):
                snake_direction = (1, 0)

    # 移动贪吃蛇
    head_x = snake[0][0] + snake_direction[0] * GRID_SIZE
    head_y = snake[0][1] + snake_direction[1] * GRID_SIZE

    # 检查是否吃到食物
    if head_x == food[0] and head_y == food[1]:
        snake.insert(0, (head_x, head_y))
        food = (random.randrange(0, WIDTH // GRID_SIZE) * GRID_SIZE,
                random.randrange(0, HEIGHT // GRID_SIZE) * GRID_SIZE)
    else:
        snake.insert(0, (head_x, head_y))
        snake.pop()

    # 检查是否撞墙或撞到自己
    if (head_x < 0 or head_x >= WIDTH or
            head_y < 0 or head_y >= HEIGHT or
            (head_x, head_y) in snake[1:]):
        running = False

    # 绘制游戏画面
    screen.fill(BLACK)
    for segment in snake:
        pygame.draw.rect(screen, GREEN, (segment[0], segment[1], GRID_SIZE, GRID_SIZE))
    pygame.draw.rect(screen, RED, (food[0], food[1], GRID_SIZE, GRID_SIZE))
    pygame.display.flip()

    # 控制游戏速度
    clock.tick(SNAKE_SPEED)

# 退出 Pygame
pygame.quit()